/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem A. Archery Tournament                                  */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Artem Vasilyev                           */
/* Test set              Artem Vasilyev                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Artem Vasilyev                           */
/******************************************************************/

import java.io.*;
import java.util.*;

public class archery_av_tl_n2 {

    final int INF = Integer.MAX_VALUE;
    final int MAX_CIRCLES = 50;

    void solve() {
        int n = in.nextInt();
        Query[] qs = new Query[n];
        for (int i = 0; i < n; i++) {
            qs[i] = new Query(in.nextInt(), in.nextInt(), in.nextInt());
        }
        boolean[] alive = new boolean[n];
        for (int i = 0; i < n; i++) {
            if (qs[i].type == 1) {
                for (int j = 0; j < i; j++) {
                    if (qs[j].type == 1 && alive[j]) {
                        long dist2 = (long) (qs[i].x - qs[j].x) * (qs[i].x - qs[j].x) + (long) (qs[i].y - qs[j].y) * (qs[i].y - qs[j].y);
                        if (dist2 < (long) (qs[i].y + qs[j].y) * (qs[i].y + qs[j].y)) {
                            throw new AssertionError(qs[i].x + " " + qs[i].y + " " + qs[j].x + " " + qs[j].y);
                        }
                    }
                }
                alive[i] = true;
            } else {
                int inter = -1;
                for (int j = 0; j < i; j++) {
                    if (qs[j].type == 1 && alive[j]) {
                        long dist2 = (long) (qs[i].x - qs[j].x) * (qs[i].x - qs[j].x) + (long) (qs[i].y - qs[j].y) * (qs[i].y - qs[j].y);
                        if (dist2 < (long) qs[j].y * qs[j].y) {
                            if (inter != -1) {
                                throw new AssertionError();
                            }
                            inter = j;
                            alive[j] = false;
                        }
                    }
                }
                out.println(inter == -1 ? inter : (inter + 1));
            }
        }
    }

    class Query {
        int type, x, y;

        public Query(int type, int x, int y) {
            this.type = type;
            this.x = x;
            this.y = y;
        }

        @Override
        public String toString() {
            return "Query{" +
                    "type=" + type +
                    ", x=" + x +
                    ", y=" + y +
                    '}';
        }
    }

    void run() throws FileNotFoundException {
        in = new FastScanner();
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    FastScanner in;
    PrintWriter out;

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        public FastScanner(String s) {
            try {
                br = new BufferedReader(new FileReader(s));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public String nextToken() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                }
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(nextToken());
        }

        public long nextLong() {
            return Long.parseLong(nextToken());
        }

        public double nextDouble() {
            return Double.parseDouble(nextToken());
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        new archery_av_tl_n2().run();
    }
}

