/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem A. Archery Tournament                                  */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Artem Vasilyev                           */
/* Test set              Artem Vasilyev                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Roman Elizarov                           */
/******************************************************************/


fun sqd(x: Int, y: Int) = x.toLong() * x + y.toLong() * y

class Target(val x: Int, val y: Int, val i: Int) {
    val a = x - y
    val b = x + y
    fun isHit(xh: Int, yh: Int): Boolean =
        sqd(x - xh, y - yh) < y.toLong() * y

}
class Tree(var l: Tree? = null, var r: Tree? = null, var s: MutableSet<Target>? = null) {
    val ll: Tree get() = l ?: Tree().also { l = it }
    val rr: Tree get() = r ?: Tree().also { r = it }
    val ss: MutableSet<Target> = s ?: HashSet<Target>().also { s = it }
}

fun Tree.update(z: IntArray, a: Int, b: Int, t: Target, act: MutableSet<Target>.(Target) -> Unit) {
    if (t.a <= z[a] && t.b >= z[b]) {
        ss.act(t)
    } else {
        val m = (a + b) / 2
        if (t.a < z[m]) ll.update(z, a, m, t, act)
        if (t.b > z[m]) rr.update(z, m, b, t, act)
    }
}

fun Tree.shoot(z: IntArray, a: Int, b: Int, x: Int, y: Int): Target? {
    if (b < a) return null
    s?.forEach { if (it.isHit(x, y)) return it }
    val m = (a + b) / 2
    if (x <= z[m]) l?.shoot(z, a, m, x, y)?.let { return it }
    if (x > z[m]) r?.shoot(z, m, b, x, y)?.let { return it }
    return null
}

class Req(val t: Int, val x: Int, val y: Int, val i: Int)

fun main(args: Array<String>) {
    val root = Tree()
    val reqs = List(readLine()!!.toInt()) { i ->
        val (t, x, y) = readLine()!!.split(" " ).map { it.toInt() }
        Req(t, x, y, i)
    }
    val z = reqs.filter { it.t == 1 }.flatMap { listOf(it.x - it.y, it.x + it.y) }.toSortedSet().toIntArray()
    for (r in reqs) with(r) {
        when (t) {
            1 -> {
                root.update(z, 0, z.lastIndex, Target(x, y, i)) { add(it) }
            }
            2 -> {
                root.shoot(z, 0, z.lastIndex, x, y)?.let { hit ->
                    println(hit.i + 1)
                    root.update(z, 0, z.lastIndex, hit) { remove(it) }
                } ?: println(-1)
            }
        }
    }
}
