/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem A. Archery Tournament                                  */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Artem Vasilyev                           */
/* Test set              Artem Vasilyev                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gennady Korotkevich                      */
/******************************************************************/

/**
 *    author:  tourist
 *    created: 29.11.2017 13:49:46       
**/
#include <bits/stdc++.h>

using namespace std;

const int N = 200010;

const int MAX = (int) 2e9;

int op[N], x[N], y[N];
int from[N], to[N], rx[N];

set< pair<int,int> > s[12 * N][2];
vector<int> all;

void modify(int v, int l, int r, int ll, int rr, int id, bool add) {
  int mid = (l + r) >> 1;
  if (ll <= mid && mid + 1 <= rr) {
    if (add) {
      s[v][0].emplace(from[id], id);
      s[v][1].emplace(to[id], id);
    } else {
      s[v][0].erase({from[id], id});
      s[v][1].erase({to[id], id});
    }
    return;
  }
  if (rr <= mid) {
    modify(v + v, l, mid, ll, rr, id, add);
  } else {
    modify(v + v + 1, mid + 1, r, ll, rr, id, add);
  }
}

void get(int v, int l, int r, int p) {
  if (l == r) {
    return;
  }
  int mid = (l + r) >> 1;
  if (p <= mid) {
    auto it = s[v][0].begin();
    while (it != s[v][0].end()) {
      if (it->first > p) {
        break;
      }
      all.push_back(it->second);
      ++it;
    }
    get(v + v, l, mid, p);
  } else {
    auto it = s[v][1].end();
    while (it != s[v][1].begin()) {
      --it;
      if (it->first < p) {
        break;
      }
      all.push_back(it->second);
    }
    get(v + v + 1, mid + 1, r, p);
  }
}

int main() {
  int n;
  scanf("%d", &n);
  vector< pair<int,int> > e;
  for (int i = 0; i < n; i++) {
    scanf("%d %d %d", &op[i], &x[i], &y[i]);
    if (op[i] == 1) {
      from[i] = x[i] - y[i];
      to[i] = x[i] + y[i];
      e.emplace_back(from[i], ~i);
      e.emplace_back(to[i], n + i);
    } else {
      e.emplace_back(x[i], i);
    }
  }
  sort(e.begin(), e.end());
  int t = (int) e.size();
  for (int i = 0; i < t; i++) {
    int id = e[i].second;
    if (id < 0) {
      from[~id] = i;
    } else {
      if (id < n) {
        rx[id] = i;
      } else {
        to[id - n] = i;
      }
    }
  }
  vector<bool> alive(n, true);
  for (int i = 0; i < n; i++) {
    if (op[i] == 1) {
      modify(1, 0, t - 1, from[i], to[i], i, true);
    } else {
      all.clear();
      get(1, 0, t - 1, rx[i]);
      int ans = -1;
      for (int id : all) {
        if (!alive[id]) {
          continue;
        }
        long long dist = (long long) (x[i] - x[id]) * (x[i] - x[id]) + (long long) (y[i] - y[id]) * (y[i] - y[id]);
        if (dist < (long long) y[id] * y[id]) {
//          modify(1, 0, t - 1, from[id], to[id], id, false);
          assert(ans == -1);
          ans = id + 1;
          alive[id] = false;
        }
      }
      printf("%d\n", ans);
    }
  }
  return 0;
}

