/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem B. Box                                                 */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Niyaz Nigmatullin                        */
/* Test set              Niyaz Nigmatullin                        */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Sergey Melnikov                          */
/******************************************************************/

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.StringTokenizer;
 
public class box_sm {
    FastScanner in;
    PrintWriter out;
 
    public void solve() throws IOException {
        ArrayList<Long> sizes = new ArrayList<>();
        for (int i = 0; i < 3; i++) {
            sizes.add(in.nextLong());
        }
        long w = in.nextLong();
        long h = in.nextLong();
        Random random = new Random(1);
        for (int it = 0; it < 100000; it++) {
            Collections.shuffle(sizes, random);
            long a = sizes.get(0);
            long b = sizes.get(1);
            long c = sizes.get(2);
            if (2 * a + 2 * c <= w && b + 2 * c <= h) {
                out.println("Yes");
                return;
            }
            if (2 * a + 2 * c <= h && b + 2 * c <= w) {
                out.println("Yes");
                return;
            }
            if (a + c <= w && 3 * b + a +  c <= h) {
                out.println("Yes");
                return;
            }
            if (a + c <= h && 3 * b + a +  c <= w) {
                out.println("Yes");
                return;
            }
        }
        out.println("No");
    }
 
    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);
            solve();
 
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
 
    class FastScanner {
        BufferedReader br;
        StringTokenizer st;
 
        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }
 
        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
 
        int nextInt() {
            return Integer.parseInt(next());
        }
 
        long nextLong() {
            return Long.parseLong(next());
        }
 
        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
 
    public static void main(String[] arg) {
        new box_sm().run();
    }
}
