/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem C. Connections                                         */
/*                                                                */
/* Original idea         Pavel Irzhavski                          */
/* Problem statement     Pavel Irzhavski                          */
/* Test set              Pavel Irzhavski                          */
/******************************************************************/
/* Checker                                                        */
/*                                                                */
/* Author                Pavel Irzhavski                          */
/******************************************************************/

#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

int DFS(const vector<vector<int> > &G, int v, vector<char> &visited)
{
	visited[v] = 1;
	int k = 1;

	for (int i = 0; i < G[v].size(); i++)
		if (!visited[G[v][i]])
			k += DFS(G, G[v][i], visited);

	return k;
}

bool isStrong(vector<pair<int, int> > arcs, int n)
{
	for (int _ = 0; _ < 2; _++)
	{
		vector<vector<int> > G(n + 1);
		for (int i = 0; i < arcs.size(); i++)
			G[arcs[i].first].push_back(arcs[i].second);

		vector<char> visited(n + 1);
		if (DFS(G, 1, visited) != n)
			return false;

		for (int i = 0; i < arcs.size(); i++)
			swap(arcs[i].first, arcs[i].second);
	}

	return true;
}

int main(int argc, char *argv[])
{
	registerTestlibCmd(argc, argv);

	int tests = inf.readInt();

	for (int t = 1; t <= tests; t++)
	{
		int n = inf.readInt();
		int m = inf.readInt();

		vector<pair<int, int> > arcs;
		for (int i = 0; i < m; i++)
		{
			int u = inf.readInt();
			int v = inf.readInt();
			arcs.push_back(make_pair(u, v));
		}

		vector<pair<int, int> > removed;

		for (int i = 0; i < m - 2 * n; i++)
		{
			int u = ouf.readInt(1, n, "tail");
			int v = ouf.readInt(1, n, "head");
			removed.push_back(make_pair(u, v));
		}

		sort(arcs.begin(), arcs.end());
		sort(removed.begin(), removed.end());

		int k = 0;
		for (int i = 0, j = 0; i < arcs.size(); i++)
			if (k < removed.size() && arcs[i] == removed[k])
				k++;
			else
				arcs[j++] = arcs[i];

		if (k < removed.size())
		{
			quitf(_wa, "Output for the case %d contains a bad or duplicated arc %d %d", t, removed[k].first, removed[k].second);
		}
		else
		{
			arcs.resize(2 * n);
			if (!isStrong(arcs, n))
				quitf(_wa, "Subgraph in case %d is not strongly connected", t);
		}
	}

	quitf(_ok, "[OK] %d testcases", tests);
}

