/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem C. Connections                                         */
/*                                                                */
/* Original idea         Pavel Irzhavski                          */
/* Problem statement     Pavel Irzhavski                          */
/* Test set              Pavel Irzhavski                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Andrei Lopatin                           */
/******************************************************************/

import java.io.*;
import java.util.*;
import java.awt.*;
 
public class connections_al {
    static ArrayList <Integer> G[];
    static ArrayList <Integer> Z[];
    static HashSet <Integer> Q[];
    static int L[], V[], W[], T[], R[];
    static int F[];
    static int ct;
    static int [] x, y;
     
    static void dfs (int v) {
      F[v] = 1;
      T[v] = ct;
      R[ct] = v;
      L[v] = ct;
      ++ct;
      //boolean flag = false;
      for (int h : G[v]) {
        if (F[h] == 2) {
          if (L[h] < L[v]) {
            L[v] = L[h];
            W[v] = h;
            V[v] = v;
          }
        }
        if (F[h] == 0) {
          dfs (h);
        //}
        //if (F[h] == 2) {
          if (L[h] < L[v]) {
            L[v] = L[h];
            W[v] = R[L[h]];
            V[v] = V[h];
          }
          Q[v].add (h);
          //System.out.println (v + " " + h);
        }
        if (F[h] == 1/* && !flag*/) {
          if (T[h] < L[v]) {
            L[v] = T[h];
            V[v] = v;
          }
        }
      }
      F[v] = 2;
      //System.out.println (V[v] + " " + R[L[v]]);
      Q[V[v]].add (R[L[v]]);
    }
     
    static int dfs2 (int v) {
      F[v] = 1;
      int res = 1;
      for (int h : Z[v])
        if (F[h] == 0) {
          F[h] = 1;
          res += dfs2 (h);
        }
      return res;
    }
 
    public static void main (String args []) throws Exception {
        BufferedReader in = new BufferedReader (new InputStreamReader (System.in));
        PrintWriter out = new PrintWriter (new BufferedWriter (new OutputStreamWriter (System.out)));
        int q = Integer.parseInt (in.readLine ());
        for (int z = 0; z < q; z++) {
            StringTokenizer t = new StringTokenizer (in.readLine ());
            int n = Integer.parseInt (t.nextToken ());
            int m = Integer.parseInt (t.nextToken ());
            G = new ArrayList [n];
            Q = new HashSet [n];
            Z = new ArrayList [n];
            L = new int [n];
            V = new int [n];
            W = new int [n];
            F = new int [n];
            x = new int [m];
            y = new int [m];
            T = new int [n];
            R = new int [n];
            ct = 0;
            for (int i = 0; i < n; i++) {
                G[i] = new ArrayList <Integer> ();
                Q[i] = new HashSet <Integer> ();
                Z[i] = new ArrayList <Integer> ();
            }
            for (int i = 0; i < m; i++) {
                t = new StringTokenizer (in.readLine ());
                int a = Integer.parseInt (t.nextToken ()) - 1;
                int b = Integer.parseInt (t.nextToken ()) - 1;
                G[a].add (b);
                x[i] = a;
                y[i] = b;
            }
            int cnt = 0;
            dfs (0);
            for (int i = 0; i < m; i++) {
              if (Q[x[i]].contains (y[i])) {
                ++cnt;
                Z[x[i]].add (y[i]);
                x[i] = -1;
                y[i] = -1;
              }
            }
            //out.println (cnt);
            if (cnt > 2 * n) throw new RuntimeException ("fail");
            /*for (int i = 0; i < n; i++) {
              F = new int [n];
              int res = dfs2 (i);
              if (res != n) out.println (i + " --> " + res);//throw new RuntimeException ("Case " + (z + 1));
            }*/
            for (int i = 0; i < m && cnt < 2 * n; i++)
              if (x[i] >= 0) {
                x[i] = -1;
                y[i] = -1;
                ++cnt;
              }
            //out.println (cnt);
            for (int i = 0; i < m; i++)
              if (x[i] >= 0) {
                out.println ((x[i] + 1) + " " + (y[i] + 1));
              }
        }
         
        out.close ();
    }
}
