/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem C. Connections                                         */
/*                                                                */
/* Original idea         Pavel Irzhavski                          */
/* Problem statement     Pavel Irzhavski                          */
/* Test set              Pavel Irzhavski                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Borys Minaiev                            */
/******************************************************************/

import java.io.*;
import java.util.*;

public class connections_bm {
    private FastScanner in;
    private PrintWriter out;

    class Edge {
        int fr, to;
        boolean used;

        public Edge(int fr, int to) {
            this.fr = fr;
            this.to = to;
        }
    }

    void color(List<Edge>[] g, int v, boolean[] was) {
        was[v] = true;
        for (Edge e : g[v]) {
            int to = e.fr + e.to - v;
            if (!was[to]) {
                was[to] = true;
                e.used = true;
                color(g, to, was);
            }
        }
    }

    void go(int v, List<Integer>[] g, boolean[] was) {
        was[v] = true;
        for (int to : g[v]) {
            if (!was[to]) {
                go(to, g, was);
            }
        }
    }

    private void solve() {
        int tc = in.nextInt();
        for (int t = 0; t < tc; t++) {
            int n = in.nextInt();
            int m = in.nextInt();
            List<Edge>[] g = new ArrayList[n];
            List<Edge>[] gBack = new ArrayList[n];
            for (int i = 0; i < n; i++) {
                g[i] = new ArrayList<>();
                gBack[i] = new ArrayList<>();
            }
            for (int i = 0; i < m; i++) {
                int fr = in.nextInt() - 1;
                int to = in.nextInt() - 1;
                Edge e = new Edge(fr, to);
                g[fr].add(e);
                gBack[to].add(e);
            }
            color(g, 0, new boolean[n]);
            color(gBack, 0, new boolean[n]);
            int used = 0;
            for (int i = 0; i < n; i++) {
                for (Edge e : g[i]) {
                    if (e.used) {
                        used++;
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                for (Edge e : g[i]) {
                    if (used < 2 * n && !e.used) {
                        e.used = true;
                        used++;
                    }
                }
            }
            List<Integer>[] gg = new ArrayList[n];
            List<Integer>[] ggBack = new ArrayList[n];
            for (int i = 0; i < n; i++) {
                ggBack[i] = new ArrayList<>();
            }
            for (int i = 0; i < n; i++) {
                gg[i] = new ArrayList<>();
                for (Edge e : g[i]) {
                    if (e.used) {
                        gg[i].add(e.to);
                        ggBack[e.to].add(i);
                    }
                }
            }
            boolean[] was = new boolean[n];
            go(0, gg, was);
            for (int i = 0; i < n; i++) {
                if (!was[i]) {
                    throw new AssertionError();
                }
            }
            Arrays.fill(was, false);
            go(0, ggBack, was);
            for (int i = 0; i < n; i++) {
                if (!was[i]) {
                    throw new AssertionError();
                }
            }
            for (int i = 0; i < n; i++) {
                for (Edge e : g[i]) {
                    if (!e.used) {
                        out.println((e.fr + 1) + " " + (e.to + 1));
                    }
                }
            }
        }
    }

    private void run() {
        try {
            in = new FastScanner(new File("connections.in"));
            out = new PrintWriter(new File("connections.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private void runIO() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    private class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    public static void main(String[] args) {
        new connections_bm().runIO();
    }
}
