/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem C. Connections                                         */
/*                                                                */
/* Original idea         Pavel Irzhavski                          */
/* Problem statement     Pavel Irzhavski                          */
/* Test set              Pavel Irzhavski                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Irzhavski                          */
/******************************************************************/

#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

void DFS(const vector<vector<int> > &G, const vector<int> &heads, int v, vector<char> &visited, vector<char> &useful)
{
	visited[v] = 1;

	for (int i = 0; i < G[v].size(); i++)
	{
		int e = G[v][i];
		int u = heads[e];

		if (!visited[u])
		{
			useful[e] = 1;
			DFS(G, heads, u, visited, useful);
		}
	}
}

int main()
{
	int tests;
	scanf("%d", &tests);
	for (int test = 0; test < tests; test++)
	{
		int n, m;
		scanf("%d%d", &n, &m);

		vector<int> tails(m);
		vector<int> heads(m);
		for (int i = 0; i < m; i++)
			scanf("%d%d", &tails[i], &heads[i]);

		vector<char> useful(m);
		for (int _ = 0; _ < 2; _++)
		{
			vector<vector<int> > G(n + 1);
			for (int i = 0; i < m; i++)
				G[tails[i]].push_back(i);

			vector<char> visited(n + 1);
			DFS(G, heads, 1, visited, useful);
			tails.swap(heads);
		}

		for (int i = 0, k = 0; k < m - 2 * n; i++)
			if (!useful[i])
			{
				printf("%d %d\n", tails[i], heads[i]);
				k++;
			}
	}
	return 0;
}

