/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem C. Connections                                         */
/*                                                                */
/* Original idea         Pavel Irzhavski                          */
/* Problem statement     Pavel Irzhavski                          */
/* Test set              Pavel Irzhavski                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Roman Elizarov                           */
/******************************************************************/

class Edge(val a: Int, val b: Int, val i: Int)

fun main(args: Array<String>) {
    repeat(readLine()!!.toInt()) {
        val (n, m) = readLine()!!.split(" ").map { it.toInt() }
        val r = List(m) { i ->
            readLine()!!.split(" ").map { it.toInt() }.let { Edge(it[0], it[1], i) }
        }
        val p1 = pick(r)
        val p2 = pick(r.map { Edge(it.b, it.a, it.i) })
        val p = p1 + p2
        r.filter { it.i !in p }.take(m - 2 * n).forEach { println("${it.a} ${it.b}") }
    }
}

fun pick(r: List<Edge>): Set<Int> {
    val g = r.groupBy { it.a }
    val u = mutableSetOf<Int>()
    var last = -1
    val res = mutableSetOf<Int>()
    fun dfs(a: Int) {
        u += a
        last = a
        for (e in g[a]!!) if (e.b !in u) {
            res += e.i
            dfs(e.b)
        }
    }
    dfs(1)
    return res
}

