/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem D. Designing the Toy                                   */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Anton Kovsharov                          */
/******************************************************************/

import java.util.*;
import java.io.*;
 
public class design_ak {
    FastScanner in;
    PrintWriter out;
 
    class Coord implements Comparable<Coord> {
        int val;
        int id;
         
        public Coord(int val, int id) {
            super();
            this.val = val;
            this.id = id;
        }
 
        @Override
        public int compareTo(Coord o) {
            if (val != o.val) {
                return Integer.compare(val, o.val);
            }
            return Integer.compare(id, o.id);
        }
    }
     
    class Point {
        int x, y, z;
 
        public Point(int x, int y, int z) {
            super();
            this.x = x;
            this.y = y;
            this.z = z;
        }
    }
     
    public void solve() throws IOException {
        Coord[] cs = new Coord[3];
        cs[2] = new Coord(in.nextInt(), 2);
        cs[1] = new Coord(in.nextInt(), 1);
        cs[0] = new Coord(in.nextInt(), 0);
     
        Arrays.sort(cs);
        if (cs[2].val > cs[0].val * cs[1].val) {
            out.println(-1);
            return;
        }
        int a = cs[0].val;
        int b = cs[1].val;
        int c = cs[2].val;
        ArrayList<Point> res = new ArrayList();
        boolean[][] busy = new boolean[a][b];
        for (int i = 0; i < b; i++) {
            Point p = new Point(Math.min(i, a - 1), i, 0);
            res.add(p);
            busy[p.x][p.y] = true;
        }
        int need = c - b;
        for (int i = 0; i < a; i++) {
            for (int j = 0; j < b; j++) {
                if (!busy[i][j] && need > 0) {
                    need--;
                    busy[i][j] = true;
                    Point p = new Point(i, j, 0);
                    res.add(p);
                }
            }
        }
        int[] inv = new int[3];
        for (int i = 0; i < 3; i++) {
            inv[cs[i].id] = i;
        }
        out.println(res.size());
        for (Point p : res) {
            int[] q = new int[3];
            q[0] = p.y;
            q[1] = p.x;
            q[2] = p.z;
            for (int i = 0; i < 3; i++) {
                out.print(q[inv[i]] + " ");
            }
            out.println();
        }
    }
 
    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);
 
            solve();
 
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
 
    class FastScanner {
        BufferedReader br;
        StringTokenizer st;
 
        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }
 
        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
 
        int nextInt() {
            return Integer.parseInt(next());
        }
 
        long nextLong() {
            return Long.parseLong(next());
        }
 
        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
 
    public static void main(String[] arg) {
        new design_ak().run();
    }
}
