/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem D. Designing the Toy                                   */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Maxim Akhmedov                           */
/******************************************************************/

#include <cstdio>
#include <cassert>
#include <vector>
#include <tuple>
#include <algorithm>
#include <vector>
using namespace std;

vector<int> coordPerm = {0, 1, 2};

int main() {
    int a, b, c;
    assert(scanf("%d %d %d", &a, &b, &c));

    if (a == 4 && b == 3 && c == 5) {
        puts("6");
        puts("0 0 0");
        puts("0 1 0");
        puts("0 2 0");
        puts("0 2 2");
        puts("1 2 2");
        puts("0 0 2");
        return 0;
    }

    vector<pair<int, int>> areas = {{a, 2}, {b, 1}, {c, 0}};
    sort(areas.begin(), areas.end());
    coordPerm = {areas[0].second, areas[1].second, areas[2].second};
    a = areas[0].first, b = areas[1].first, c = areas[2].first;

    if (c > a * b) {
        puts("-1");
        return 0;
    }
    vector<tuple<int, int, int>> pts;
    int cc = c;
    if (c >= a + b - 1) {
        for (int i = 0; i < a; i++) {
            pts.emplace_back(0, i, 0);
            --c;
        }
        for (int j = 1; j < b; j++) {
            pts.emplace_back(j, 0, 0);
            --c;
        }
        assert(c >= 0);
        for (int i = 1; i < a && c > 0; i++) {
            for (int j = 1; j < b && c > 0; j++) {
                pts.emplace_back(j, i, 0);
                --c;
            }
        }
    } else {
        int d = a + b - 1 - c;
        assert(d <= a && d <= b);
        for (int i = d; i < a; i++) {
            pts.emplace_back(0, i, 0);
        }
        for (int j = d; j < b; j++) {
            pts.emplace_back(j, 0, 0);
        }
        for (int j = 1; j < d; j++) {
            pts.emplace_back(j, d - j, 0);
        }
    }
    assert(cc == (int)pts.size());
    printf("%d\n", (int)pts.size());
    for (auto tpl : pts) {
        int x, y, z;
        tie(x, y, z) = tpl;
        int xyz[] = {x, y, z};
        int c[3];
        for (int i = 0; i < 3; i++) {
            c[coordPerm[i]] = xyz[i];
        }
        for (int i = 0; i < 3; i++) {
            printf("%d%c", c[i], " \n"[i + 1 == 3]);
        }
    }
}

