/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem E. Easy Quest                                          */
/*                                                                */
/* Original idea         Pavel Mavrin                             */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Checker                                                        */
/*                                                                */
/* Author                Pavel Mavrin                             */
/******************************************************************/

import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import static ru.ifmo.testlib.Outcome.Type.FAIL;
import static ru.ifmo.testlib.Outcome.Type.OK;
import static ru.ifmo.testlib.Outcome.Type.WA;

public class Check implements Checker {

    static final int MAX = 1000;

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        int[] a = new int[n];
        int m = 0;
        for (int i = 0; i < n; i++) {
            a[i] = inf.nextInt();
            if (a[i] == 0) m++;
        }
        String user = ouf.nextLine().trim();
        String jury = ans.nextLine().trim();
        if (user.equals("No")) {
            if (jury.equals("No")) {
                return new Outcome(OK, "OK, no solution");
            } else {
                return new Outcome(WA, "Solution exists");
            }
        } else if (user.equals("Yes")) {
            int[] res = new int[m];
            for (int i = 0; i < m; i++) {
                res[i] = ouf.nextInt();
                if (res[i] < 1 || res[i] > MAX) {
                    return new Outcome(WA, "Invalid type " + res[i]);
                }
            }
            int k = 0;
            int[] cnt = new int[MAX + 1];
            for (int i = 0; i < n; i++) {
                if (a[i] > 0) {
                    cnt[a[i]]++;
                } else if (a[i] == 0) {
                    cnt[res[k++]]++;
                } else {
                    cnt[-a[i]]--;
                    if (cnt[-a[i]] < 0) {
                        return new Outcome(WA, "No item on step " + (i + 1));
                    }
                }
            }
            if (jury.equals("No")) {
                return new Outcome(FAIL, "Found solution that jury did not find");
            } else {
                return new Outcome(OK, "OK, found correct solution");
            }
        } else {
            return new Outcome(WA, "expected 'Yes' or 'No', but found " + user);
        }
    }
}

