/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem E. Easy Quest                                          */
/*                                                                */
/* Original idea         Pavel Mavrin                             */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Mavrin                             */
/******************************************************************/

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Pavel Mavrin
 */
public class easy_pm {

    private static final int MAX = 1000;

    private void solve() throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        int m = 0;
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            if (a[i] == 0) m++;
        }
        int[] res = new int[m];
        Arrays.fill(res, 1);
        m = 0;
        int[] cnt = new int[MAX + 1];
        for (int i = 0; i < n; i++) {
            if (a[i] >= 0) {
                cnt[a[i]]++;
            } else {
                if (cnt[-a[i]] > 0) {
                    cnt[-a[i]]--;
                } else {
                    if (cnt[0] > 0) {
                        res[m++] = -a[i];
                        cnt[0]--;
                    } else {
                        out.println("No");
                        return;
                    }
                }
            }
        }
        out.println("Yes");
        for (int i = 0; i < res.length; i++) {
            if (i > 0) out.print(" ");
            out.print(res[i]);
        }
        out.println();
    }

    // ------------------

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        new easy_pm().run();
    }

    private void run() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(new OutputStreamWriter(System.out));
        solve();
        out.close();
    }

}

