/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem F. The Final Level                                     */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Pavel Kunyavsky                          */
/* Test set              Pavel Kunyavsky                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavsky                          */
/******************************************************************/

#include <cstdio>
#include <cassert>
#include <vector>
#include <cmath>

using namespace std;

struct rect {
  int x1, y1;
  int x2, y2;
};

int inva, invb, invd;
int sa, sb;
vector<rect> ans;
void add(int x1, int y1, int x2, int y2) {
  x1 += sa;
  x2 += sa;
  y1 += sb;
  y2 += sb;
  if (invd) {
    swap(x1, y2);
    swap(x2, y1);
  }
  if (inva) {
    x1 = -x1;
    x2 = -x2;
  }
  if (invb) {
    y1 = -y1;
    y2 = -y2;
  }

  ans.push_back({x1, y1, x2, y2});
}

void solve(int a, int b, int n) {
  inva = invb = invd = 0;
  sa = sb = 0;
  ans.clear();
  if (a < 0) {
    inva ^= 1;
    a = -a;
  }
  if (b < 0) {
    invb ^= 1;
    b = -b;
  }

  while (a > 0 || b > 0) {
    if (a > b && a > n - 1) {
      invd ^= 1;
      swap(a, b);
      swap(sa, sb);
    }
    if (a > n - 1) {
      add(n - 1, n - 1, 0, 0);
      b -= n; sb += n;
      a -= n - 1; sa += n -1;
    } else {
      add(a, n - 1, a - (n - 1), 0);
      b -= n; sb += n;
      sa += a;
      a = 0;
    }
  }

  if (a == 0 && b == 0) {
    add(n - 1, n - 1, 0, 0);
  }

  printf("%d\n", (int)ans.size());
  for (const auto& x : ans) {
    printf("%d %d %d %d\n", x.x1, x.y1, x.x2, x.y2);
  }
}

int main() {
  int k;
  scanf("%d", &k);
  int a, b, n;
  for (int i = 0; i < k; i++) {
    scanf("%d%d%d", &a, &b, &n);
    solve(a, b, n);
  }
}

