/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem F. The Final Level                                     */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Pavel Kunyavsky                          */
/* Test set              Pavel Kunyavsky                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Mavrin                             */
/******************************************************************/

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * @author Pavel Mavrin
 */
public class final_pm {

    private void solve() throws IOException {
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            solveTest();
        }
    }

    private void solveTest() throws IOException {
        int a = nextInt();
        int b = nextInt();
        int n = nextInt();
        boolean xFlipped = false;
        boolean yFlipped = false;
        if (a < 0) {
            xFlipped = true;
            a = -a;
        }
        if (b < 0) {
            yFlipped = true;
            b = -b;
        }
        List<int[]> res = new ArrayList<>();
        int x = 0;
        int y = 0;
        int st = 0;
        while (true) {
            if (a > x + n - 1 && b > y + n - 1) {
                res.add(new int[]{x + n - 1, y + n - 1, x, y});
                x += n - 1;
                y += n - 1;
                if (a > x + n - 1 && a - x > b - y) {
                    x++;
                    st = 1;
                } else {
                    y++;
                    st = 0;
                }
            } else if (a > x + n - 1) {
                res.add(new int[]{x + n - 1, y + n - 1, x, y});
                x += n;
                st = 1;
            } else if (b > y + n - 1) {
                res.add(new int[]{x, y, x + n - 1, y + n - 1});
                y += n;
                st = 0;
            } else {
                if (st == 0) {
                    res.add(new int[]{a, y + n - 1, a - n + 1, y});
                } else {
                    res.add(new int[]{x, b - n + 1, x + n - 1, b});
                }
                break;
            }
        }
        out.println(res.size());
        for (int[] p : res) {
            if (xFlipped) {
                p[0] = -p[0];
                p[2] = -p[2];
            }
            if (yFlipped) {
                p[1] = -p[1];
                p[3] = -p[3];
            }
            out.println(p[0] + " " + p[1] + " " + p[2] + " " + p[3]);
        }
    }

    // ------------------

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        new final_pm().run();
    }

    private void run() throws IOException {
        solve();
        out.close();
    }

}

