/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem F. The Final Level                                     */
/*                                                                */
/* Original idea         Georgiy Korneev                          */
/* Problem statement     Pavel Kunyavsky                          */
/* Test set              Pavel Kunyavsky                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Roman Elizarov                           */
/******************************************************************/

fun abs(x: Int) = if (x < 0) -x else x

data class Block(val xv: Int, val yv: Int, val xh: Int, val yh: Int) {
    fun app(f: Boolean, op: Block.() -> Block) = if (f) op() else this
    fun sx(xs: Int) = Block(xv - xs, yv, xh - xs, yh)
    fun xf() = Block(-xv, yv, -xh, yh)
    fun yf() = Block(xv, -yv, xh, -yh)
    fun mir() = Block(yh, xh, yv, xv)
    override fun toString() = "$xv $yv $xh $yh"
}

fun JB(x: Int, y: Int, n: Int) = Block(x + n - 1, y + n - 1, x, y)

fun main(args: Array<String>) {
    repeat(readLine()!!.toInt()) {
        val (a0, b0, n) = readLine()!!.split(" ").map { it.toInt() }
        val xf = a0 < 0
        val yf = b0 < 0
        val mir = abs(a0) < abs(b0)
        val (a, b) = listOf(abs(a0), abs(b0)).sortedByDescending { it }
        check(a > 0 && b >= 0 && a >= b)
        val res = mutableListOf<Block>()
        var z = JB(0, 0, n)
        res += z
        while (z.xv < a || z.yv < b) {
            if (a - z.xv >= b - z.yv) {
                z = JB(z.xv + 1, z.yv.coerceAtMost(b), n)
            } else {
                z = JB(z.xv.coerceAtMost(a), z.yv + 1, n)
            }
            res += z
        }
        val xs = z.xv - a
        println(res.size)
        for (r in res) {
           println(r
               .sx(xs)
               .app(mir, Block::mir)
               .app(xf, Block::xf)
               .app(yf, Block::yf))
        }
    }
}
