/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem G. The Great Wall                                      */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Mavrin                             */
/******************************************************************/

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Pavel Mavrin
 */
public class great_pm {

    class Tree {
        int n;
        int depth;
        int[] l, r, sum;

        void init(int size, int depth) {
            this.depth = depth;
            l = new int[size * depth];
            r = new int[size * depth];
            sum = new int[size * depth];
            clear();
        }

        void clear() {
            Arrays.fill(l, -1);
            Arrays.fill(r, -1);
            Arrays.fill(sum, 0);
            n = 1;
        }

        void add(long x, int delta) {
            if (x < 0) throw new RuntimeException();
//            System.out.println((this == inside ? "inside " : "outside ") + x + " " + delta);
            int cur = 0;
            sum[0] += delta;
            for (int i = depth - 1; i >= 0; i--) {
                int q = (int) ((x >> i) & 1);
                if (q == 0) {
                    if (l[cur] == -1) {
                        l[cur] = n++;
                    }
                    cur = l[cur];
                } else {
                    if (r[cur] == -1) {
                        r[cur] = n++;
                    }
                    cur = r[cur];
                }
                sum[cur] += delta;
            }
        }

        int calc(long x) {
            if (x < 0) return 0;
            int cur = 0;
            int res = 0;
            for (int i = depth - 1; i >= 0; i--) {
                int q = (int) ((x >> i) & 1);
                if (q == 0) {
                    cur = l[cur];
                } else {
                    if (l[cur] != -1) {
                        res += sum[l[cur]];
                    }
                    cur = r[cur];
                }
                if (cur == -1) break;
            }
            return res;
        }
    }

    int r;
    int n;
    long[] a, b, c;
    Tree inside = new Tree();
    Tree outside = new Tree();

    private void solve() throws IOException {
        n = nextInt();
        r = nextInt();
        int k = nextInt();

        a = new long[n];
        b = new long[n];
        c = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            b[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            c[i] = nextInt();
        }

        long L = 0;
        long R = n * 1000000L + 1;

        inside.init(n, 35);
        outside.init(n, 35);

        while (R > L + 1) {
            long M = (L + R) / 2;
            int t = calc(M);
            if (t < k) {
                L = M;
            } else {
                R = M;
            }
        }
        out.println(L);
    }

    private int calc(long m) {
        inside.clear();
        outside.clear();
        long s = 0;
        long w = 0;
        long lw = 0;
        long rw = 0;
        long deltaInside = -(1L << 34);
        for (int i = 0; i < n; i++) {
            if (i < r) {
                s += b[i];
            } else {
                s += a[i];
            }
            if (i >= r - 1) {
                if (i == r - 1) {
                    for (int j = 0; j <= i; j++) {
                        w += c[j] - b[j];
                    }
                    lw = w;
                } else {
                    w += (b[i] - a[i]);
                    w -= (i - r < r) ? (c[i - r] - b[i - r]) : (b[i - r] - a[i - r]);
                }
                if (i == 2 * r - 1) {
                    rw = w;
                }
                if (i - r + 1 < r) {
                    inside.add(w - deltaInside, 1);
                } else {
                    outside.add(w, 1);
                }
            }
        }
        int res = 0;
        for (int i = 0; i + r <= n; i++) {
            res += inside.calc(m - s - deltaInside);
            res += outside.calc(m - s);
            if (s + lw < m) res--;
            if (i + r < n) {
                s += a[i] - b[i];
                s += b[i + r] - a[i + r];
                inside.add(lw - deltaInside, -1);
                lw += (c[i + r] - b[i + r]) - (c[i] - b[i]);
                if (i + 2 * r <= n) {
                    outside.add(rw, -1);
                    inside.add(rw - deltaInside, 1);
                    if (i + 2 * r < n) {
                        rw += (b[i + 2 * r] - a[i + 2 * r]) - (b[i + r] - a[i + r]);
                    }
                }
                deltaInside += (c[i + r] - b[i + r]) - (b[i + r] - a[i + r]);
            }
        }
        return res;
    }

    // ------------------

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws IOException {
        new great_pm().run();
    }

    private void run() throws IOException {
        solve();
        out.close();
    }

}

