/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem G. The Great Wall                                      */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Roman Elizarov                           */
/******************************************************************/

import java.util.*

fun main(args: Array<String>) {
    val (n, r, k) = readLine()!!.split(" ").map { it.toInt() }
    val a0 = readLine()!!.split(" ").map { it.toLong() }
    val b0 = readLine()!!.split(" ").map { it.toLong() }
    val c0 = readLine()!!.split(" ").map { it.toLong() }
    val aSum = a0.sum()
    val b = b0.zip(a0) { b, a -> b - a }
    val c = c0.zip(a0) { c, a -> c - a }
    val pb = b.partialSums()
    val pc = c.partialSums()
    var ls = 0L
    var rs = pc[n] + 1
    val ss = SSet()
    while (ls + 1 < rs) {
        val ms = (ls + rs) / 2
        var count = 0
        ss.clear()
        for (y in r..n - r) {
            ss.add(pb.sumRange(y - r, y - 1))
            count += ss.countLess(ms - pb.sumRange(y, y + r - 1))
        }
        if (r > 1) {
            ss.clear()
            for (y in 1..n - r) {
                if (y >= r) {
                    ss.remove(g(pb, pc, r, y - r))
                }
                ss.add(g(pb, pc, r, y - 1))
                count += ss.countLess(ms - f(pb, pc, r, y))
            }
        }
        if (count >= k)
            rs = ms else
            ls = ms

    }
    println(ls + aSum)
}

fun g(pb: List<Long>, pc: List<Long>, r: Int, x: Int): Long =
    pc.sumRange(0, x - 1) - 2 * pb.sumRange(0, x - 1) +
    pc.sumRange(x, x + r - 1) - pb.sumRange(x, x + r - 1)

fun f(pb: List<Long>, pc: List<Long>, r: Int, y: Int): Long =
    2 * pb.sumRange(0, y - 1) - pc.sumRange(0, y - 1) +
    pb.sumRange(y, y + r - 1)

private fun List<Long>.partialSums(): List<Long> {
    val res = ArrayList<Long>(size + 1)
    var sum = 0L
    res += 0
    for (k in this) {
        sum += k
        res += sum
    }
    return res
}

private fun List<Long>.sumRange(i: Int, j: Int) =
    this[j + 1] - this[i]

val rnd = Random()

class SSet {
    var root: Node? = null

    fun add(x: Long) {
        root = root.add(Node(x))
    }

    fun remove(x: Long) {
        root = root!!.remove(x)
    }

    fun countLess(x: Long): Int = root.countLess(x)

    fun clear() {
        root = null
    }
}

class Node(
        val v: Long,
        var l: Node? = null,
        var r: Node? = null,
        val h: Int = rnd.nextInt(),
        var cnt: Int = 1)

fun Node?.countLess(x: Long): Int = when {
    this == null -> 0
    x <= v -> l.countLess(x)
    else -> l.c + 1 + r.countLess(x)
}

val Node?.c get() = if (this == null) 0 else cnt

fun Node?.add(n: Node): Node = when {
    this == null -> n
    n.h < h -> {
        val (l, r) = split(n.v)
        n.l = l
        n.r = r
        n.cnt = l.c + 1 + r.c
        n
    }
    n.v <= v -> { l = l.add(n); cnt++; this }
    else -> { r = r.add(n); cnt++; this }
}

fun Node.remove(x: Long): Node? = when {
    x < v -> { l = l!!.remove(x); cnt--; this }
    x > v -> { r = r!!.remove(x); cnt--; this }
    else -> merge(l, r)
}

fun Node?.split(x: Long): Pair<Node?, Node?> = when {
    this == null -> null to null
    x <= v -> {
        cnt -= l.c
        val (ll, lr) = l.split(x)
        cnt += lr.c
        l = lr
        ll to this
    }
    else -> {
        cnt -= r.c
        val (rl, rr) = r.split(x)
        cnt += rl.c
        r = rl
        this to rr
    }
}

fun merge(l: Node?, r: Node?): Node? = when {
    l == null -> r
    r == null -> l
    l.h < r.h -> {
        check(l.v <= r.v)
        l.cnt += r.cnt
        l.r = merge(l.r, r)
        l
    }
    else -> {
        check(l.v <= r.v)
        r.cnt += l.cnt
        r.l = merge(l, r.l)
        r
    }
}


