/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem G. The Great Wall                                      */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by vaksenov on 11.11.2017.
 */
public class great_va_n2 {
    public static void main(String[] args) {
        new great_va_n2().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public void solve() throws IOException {
        int n = nextInt();
        int L = nextInt();
        int k = nextInt();

        long sum = 0;
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            sum += a[i];
        }

        int[] b = new int[n];
        for (int i = 0; i < b.length; i++) {
            b[i] = nextInt() - a[i];
        }

        int[] c = new int[n];
        for (int i = 0; i < c.length; i++) {
            c[i] = nextInt() - a[i];
        }

        long[] pb = new long[b.length + 1];
        for (int i = 1; i < pb.length; i++) {
            pb[i] = pb[i - 1] + b[i - 1];
        }

        long[] pc = new long[c.length + 1];
        for (int i = 1; i < pc.length; i++) {
            pc[i] = pc[i - 1] + c[i - 1];
        }

        long[] sums = new long[(n - L + 1) * (n - L) / 2];
        int total = 0;
        for (int i = 0; i <= n - L; i++) {
            for (int j = i + 1; j <= n - L; j++) {
                if (i + L <= j) {
                    sums[total++] = (pb[j + L] - pb[j]) + (pb[i + L] - pb[i]);
                } else {
                    long A = pb[j] - pb[i];
                    long B = pc[i + L] - pc[j];
                    long C = pb[j + L] - pb[i + L];
                    sums[total++] = A + B + C;
                }
            }
        }

        Arrays.sort(sums, 0, total);

        out.println(sums[k - 1] + sum);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new OutputStreamWriter(System.out));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}


