/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem G. The Great Wall                                      */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by vaksenov on 11.11.2017.
 */
public class great_va_n2_bs_v2 {
    public static void main(String[] args) {
        new great_va_n2_bs_v2().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public void solve() throws IOException {
        int n = nextInt();
        int L = nextInt();
        int k = nextInt();

        long sum = 0;
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            sum += a[i];
        }

        int[] b = new int[n];
        for (int i = 0; i < b.length; i++) {
            b[i] = nextInt() - a[i];
        }

        long MAX = 0;
        int[] c = new int[n];
        for (int i = 0; i < c.length; i++) {
            c[i] = nextInt() - a[i];
            MAX += c[i];
        }

        long sc = 0;
        for (int i = 0; i < L; i++) {
            sc += c[i];
        }

        long l = -1;
        long r = MAX + 1;
        while (l < r - 1) {
            long m = (l + r) / 2;

            long pc = sc;

            long less = 0;
            for (int i = 0; i <= n - L; i++) {
                long s = pc;
                for (int j = i + 1; j <= n - L; j++) {
                    if (i + L >= j) {
                        s += b[j - 1] - c[j - 1] + b[j + L - 1];
                    } else {
                        s += b[j + L - 1] - b[j - 1];
                    }

                    if (s < m) {
                        less++;
                    }
                }
                if (i < n - L) {
                    pc += c[i + L] - c[i];
                }
            }

            if (less < k) {
                l = m;
            } else {
                r = m;
            }
        }

        out.println(r - 1 + sum);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(new OutputStreamWriter(System.out));

            long time = System.currentTimeMillis();
            solve();
            System.err.println(System.currentTimeMillis() - time);

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}


