/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem H. Hack                                                */
/*                                                                */
/* Original idea         Petr Mitrichev                           */
/* Problem statement     Petr Mitrichev                           */
/* Test set              Petr Mitrichev                           */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Petr Mitrichev                           */
/******************************************************************/

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.function.IntBinaryOperator;
import java.util.function.ToIntFunction;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Tests {
    static int nTests = 0;
    static File root = new File("tests");

    static int PQ_BITS = Interact.PQ_BITS;
    static int NUM_TESTS = Interact.NUM_TESTS;
    static Random random = new Random(43159345394151999L);

    public static void main(String[] args) throws IOException {
        for (int i = 0; i < NUM_TESTS; ++i) {
            BigInteger p = randomPrimePQ();
            BigInteger q = randomPrimePQ();
            BigInteger n = p.multiply(q);
            BigInteger m = p.subtract(BigInteger.ONE).multiply(q.subtract(BigInteger.ONE));
            BigInteger d;
            while (true) {
                d = randomUpTo(m);
                if (d.gcd(m).equals(BigInteger.ONE)) break;
            }
            test(n, d);
        }
    }

    private static BigInteger randomUpTo(BigInteger m) {
        while (true) {
            BigInteger res = new BigInteger(m.bitLength(), random);
            if (res.compareTo(m) < 0) return res;
        }
    }

    static BigInteger randomPQ() {
        return BigInteger.ONE.shiftLeft(PQ_BITS - 1).add(new BigInteger(PQ_BITS - 1, random));
    }

    static BigInteger randomPrimePQ() {
        while (true) {
            BigInteger res = randomPQ();
            if (res.isProbablePrime(100)) return res;
        }
    }

    static void test(BigInteger n, BigInteger d) throws FileNotFoundException {
        try (PrintWriter out = new PrintWriter(String.format("%s/%02d", root.getName(), ++nTests))) {
            System.out.println("Writing test " + nTests);
            out.println(n.xor(BigInteger.valueOf(Interact.KEY1)) + " " + d.xor(BigInteger.valueOf(Interact.KEY2)));
        }
    }
}

