/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem I. Interactive Sort                                    */
/*                                                                */
/* Original idea         Borys Minaiev                            */
/* Problem statement     Borys Minaiev                            */
/* Test set              Borys Minaiev                            */
/******************************************************************/
/* Tests                                                          */
/*                                                                */
/* Author                Borys Minaiev                            */
/******************************************************************/

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class Tests {
    static int nTests = 0;
    static File root = new File("tests");

    static Random random = new Random(345435362);

    public static void main(String[] args) throws IOException {
        generateSample(5, new int[]{4, 2, 1, 3, 5,});
        for (int size : new int[]{1, 2, 3, 5, 10, 20, 50, 100, 1000, 2000, 3000, 5000, 10000, 10000}) {
            test(size, random.nextInt());
        }

    }

    static void generateSample(int n, int[] vals) throws FileNotFoundException {
        List<Integer> need = Arrays.stream(vals).boxed().collect(Collectors.toList());
        for (int seed = 1; ; seed++) {
            Random rnd = new Random(seed);
            List<Integer> list = IntStream.range(1, n + 1).boxed().collect(Collectors.toList());
            Collections.shuffle(list, rnd);
            if (need.equals(list)) {
                test(n, seed);
                return;
            }
        }
    }

    static void test(int n, int randSeed) throws FileNotFoundException {
        try (PrintWriter out = new PrintWriter(String.format("%s/%02d", root.getName(), ++nTests))) {
            System.out.println("Writing test " + nTests);
            out.println(n + " " + (randSeed ^ Interact.KEY2));
        }
    }
}

