/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem I. Interactive Sort                                    */
/*                                                                */
/* Original idea         Borys Minaiev                            */
/* Problem statement     Borys Minaiev                            */
/* Test set              Borys Minaiev                            */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Anton Kovsharov                          */
/******************************************************************/

import java.util.*;
import java.io.*;
 
public class interactive_ak {
    FastScanner in;
    PrintWriter out;
     
    int[] testEven = new int[] {4, 2};
    int[] testOdd = new int[] {1, 3, 5};
     
    boolean less(int i, int j) {
        i += 1;
        j += 1;
        out.println("? " + i + " " + j);
        out.flush();
        //return testEven[i - 1] < testOdd[j - 1];
        return in.next().equals("<");
    }
     
    boolean tryDivide(int i, ArrayList<ArrayList<Integer>> groups, int id) {
        ArrayList<Integer> group = groups.get(id);
        ArrayList<Integer> less = new ArrayList();
        ArrayList<Integer> more = new ArrayList();
        for (int x : group) {
            if (!less(i, x)) {
                less.add(x);
            } else {
                more.add(x);
            }
        }
        if (less.isEmpty() || more.isEmpty()) {
            return false;
        }
        groups.remove(id);
        groups.add(id, more);
        groups.add(id, less);
        return true;
    }
     
    public void solve() throws IOException {
        int n = in.nextInt();
        int cEven = n / 2;
        int cOdd = n - cEven;
        int[] ansEven = new int[cEven];
        int[] ansOdd = new int[cOdd];
         
        ArrayList<ArrayList<Integer>> groups = new ArrayList();
        ArrayList<Integer> initGroup = new ArrayList();
        for (int i = 0; i < cOdd; i++) {
            initGroup.add(i);
        }
        groups.add(initGroup);
        for (int i = 0; i < cEven; i++) {
            int l = 0, r = groups.size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                ArrayList<Integer> group = groups.get(mid);
                int sample = group.get(0);
                if (!less(i, sample)) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            int cnt = 0;
            for (int j = 0; j < l; j++) {
                cnt += groups.get(j).size();
            }
            if (tryDivide(i, groups, l)) {
                cnt += groups.get(l).size();
            } else if (l + 1 == groups.size()) {
                cnt += groups.get(l).size();
            } else {
                tryDivide(i, groups, l + 1);
                cnt += groups.get(l).size() + groups.get(l + 1).size();
            }
            ansEven[i] = 2 * cnt;
        }
        int curOdd = 1;
        for (ArrayList<Integer> group : groups) {
            ansOdd[group.get(0)] = curOdd;
            curOdd += 2;
        }
         
        // Print result
        out.print("! ");
        for (int x : ansEven) {
            out.print(x + " ");
        }
        for (int y : ansOdd) {
            out.print(y + " ");
        }
        out.println();
        out.flush();
    }
 
    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);
 
            solve();
 
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
 
    class FastScanner {
        BufferedReader br;
        StringTokenizer st;
 
        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }
 
        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
 
        int nextInt() {
            return Integer.parseInt(next());
        }
 
        long nextLong() {
            return Long.parseLong(next());
        }
 
        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
 
    public static void main(String[] arg) {
        new interactive_ak().run();
    }
}

