/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem I. Interactive Sort                                    */
/*                                                                */
/* Original idea         Borys Minaiev                            */
/* Problem statement     Borys Minaiev                            */
/* Test set              Borys Minaiev                            */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Borys Minaiev                            */
/******************************************************************/

#include <bits/stdc++.h>

using namespace std;

int n;

int getEvenCnt() {
    return n / 2;
}

int getOddCnt() {
    return (n + 1) / 2;
}

int RAND() {
    return abs((rand() << 16) | rand());
}

bool isBigger(int i, int j) {
    cout << "? " << i + 1 << " " << j + 1 << endl << flush;
    string tmp;
    cin >> tmp;
    return tmp[0] == '>';
}

int main() {
    cin >> n;
    int evenCnt = getEvenCnt();
    int oddCnt = getOddCnt();
    vector<vector<int>> groups;
    vector<int> all(evenCnt);
    for (int i = 0; i < evenCnt; i++) {
        all[i] = i;
    }
    groups.push_back(all);
    vector<int> resB(oddCnt, -1);
    for (int it = 0; it < oddCnt; it++) {
        int bId = -1;
        while (bId == -1 || resB[bId] != -1) {
            bId = RAND() % oddCnt;
        }
        int l = 0, r = groups.size() - 1;
        while (r - l > 1) {
            int mid = (l + r) >> 1;
            vector<int> &ids = groups[mid];
            int checkId = ids[RAND() % ids.size()];
            if (isBigger(checkId, bId)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        int sum = 0;
        vector<vector<int> > newGroups;
        for (int i = 0; i < l; i++) {
            sum += groups[i].size();
            newGroups.push_back(groups[i]);
        }
        for (int x = l; x <= r; x++) {
            vector<int> now = groups[x];
            vector<int> left;
            vector<int> right;
            for (int y : now) {
                if (isBigger(y, bId)) {
                    right.push_back(y);
                } else {
                    left.push_back(y);
                    sum++;
                }
            }
            if (left.size() != 0) {
                newGroups.push_back(left);
            }
            if (right.size() != 0) {
                newGroups.push_back(right);
            }
        }
        resB[bId] = sum * 2 + 1;
        for (int i = r + 1; i < groups.size(); i++) {
            newGroups.push_back(groups[i]);
        }
        groups = newGroups;
    }
    vector<int> resA(groups.size());
    for (int i = 0; i < groups.size(); i++) {
        resA[groups[i][0]] = (i + 1) * 2;
    }
    cout << "!";
    for (int x : resA) {
        cout <<" " << x;
    }
    for (int x : resB) {
        cout << " " << x;
    }
    cout << endl << flush;
}
