/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem I. Interactive Sort                                    */
/*                                                                */
/* Original idea         Borys Minaiev                            */
/* Problem statement     Borys Minaiev                            */
/* Test set              Borys Minaiev                            */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Borys Minaiev                            */
/******************************************************************/

import java.io.*;
import java.util.*;

public class interactive_bm_random_slow {
    private FastScanner in;
    private PrintWriter out;

    private void solve() {
        int n = in.nextInt();
        int even = n / 2;
        int odd = (n + 1) / 2;
        boolean[][] g = new boolean[n][n];
        Random rnd = new Random(123);
        while (true) {
            int[] result = answerFound(g);
            if (result != null) {
                out.print("!");
                for (int x : result) {
                    out.print(" " + x);
                }
                out.println();
                return;
            }
            int x = rnd.nextInt(even);
            int y = rnd.nextInt(odd);
            if (g[x][even + y] || g[even + y][x]) {
                continue;
            }
            out.println("? " + (x + 1) + " " + (y + 1));
            out.flush();
            y += even;
            if (in.next().equals(">")) {
                int tmp = x;
                x = y;
                y = tmp;
            }
            g[x][y] = true;
            for (int a = 0; a < n; a++) {
                if (g[a][x] || (a == x)) {
                    for (int b = 0; b < n; b++) {
                        if (g[y][b] || (y == b)) {
                            g[a][b] = true;
                        }
                    }
                }
            }
        }
    }

    private int[] answerFound(boolean[][] g) {
        final int n = g.length;
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            res[i] = n;
            for (int j = 0; j < n; j++) {
                if (g[i][j]) {
                    res[i]--;
                }
            }
        }
        boolean[] have = new boolean[n];
        for (int x : res) {
            have[x - 1] = true;
        }
        for (boolean b : have) {
            if (!b) {
                return null;
            }
        }
        return res;
    }

    private void run() {
        try {
            in = new FastScanner(new File("interactive_bm_random_slow.in"));
            out = new PrintWriter(new File("interactive_bm_random_slow.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private void runIO() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    private class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    public static void main(String[] args) {
        new interactive_bm_random_slow().runIO();
    }
}
