/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem J. Journey from Petersburg to Moscow                   */
/*                                                                */
/* Original idea         Gleb Evstropov                           */
/* Problem statement     Gleb Evstropov                           */
/* Test set              Gleb Evstropov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gleb Evstropov                           */
/******************************************************************/

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 5100;
const long long inf = (long long) 1e18;

int n, m, k, s, t;
vector <pair <int, long long> > vertex[size];
long long dist[size];

long long get_path(long long shift) {
	priority_queue <pair <long long, int> > dst;

	for (int i = 0; i < n; i++) {
		dist[i] = inf;
	}
	dist[s] = 0ll;
	dst.push(mp(-dist[s], s));

    while (!dst.empty()) {
    	int cur = dst.top().sc;
    	long long cd = -dst.top().fs;
    	dst.pop();
    	if (cd != dist[cur])
    		continue;
    	
    	long long curd = dist[cur];
    	for (auto& e : vertex[cur]) {
    		int tg = e.fs;
    		long long reld = curd + max(0ll, e.sc - shift);
    		
    		if (reld < dist[tg]) {
    			dist[tg] = reld;
    			dst.push(mp(-dist[tg], tg));
    		}
    	}
    }

    return dist[t];
}

int main () {
//    freopen("journey.in", "r", stdin);
//    freopen("journey.out", "w", stdout);
    scanf("%d%d%d", &n, &m, &k);
    s = 0, t = n - 1;
    long long mx = 0ll;
    vector <int> ws;
    for (int i = 0; i < m; i++) {
    	int u, v;
    	long long c;
    	scanf("%d%d%lld", &u, &v, &c);
    	u--, v--;
    	ws.pb(c);
    	mx = max(mx, c);

    	vertex[u].pb(mp(v, c));
    	vertex[v].pb(mp(u, c));
    }

    long long best = get_path(0);

    for (int i = 0; i < (int) ws.size(); i++) {
        long long cur = get_path(ws[i]);
        best = min(best, cur + ws[i] * 1ll * k);
    }

    //cerr << (clock() + 0.0) / CLOCKS_PER_SEC << endl;
    printf("%lld\n", best);

    return 0;
}
