/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem J. Journey from Petersburg to Moscow                   */
/*                                                                */
/* Original idea         Gleb Evstropov                           */
/* Problem statement     Gleb Evstropov                           */
/* Test set              Gleb Evstropov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gleb Evstropov                           */
/******************************************************************/

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 100 * 1000 + 100;
const long long inf = (long long) 1e18;

bool used[size];
int n, m, k, s, t;
vector <pair <int, int> > vertex[size];
vector <int> edges;
long long ans;

void go(int cur) {
	if (cur == t) {
		vector <int> edges_help = edges;
		sort(edges_help.rbegin(), edges_help.rend());
		long long sum = 0;
		for (int i = 0; i < min(k, (int) edges_help.size()); i++)
			sum += edges_help[i];

		ans = min(ans, sum);
		
		return;
	}

	used[cur] = true;	

	for (auto& e : vertex[cur]) {
		if (!used[e.fs]) {
			edges.pb(e.sc);
			go(e.fs);
			edges.pop_back();
		}
	}

	used[cur] = false;
}

int main () {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    cin >> n >> m >> k;
    s = 0, t = n - 1;

    for (int i = 0; i < m; i++) {
    	int u, v, c;

    	cin >> u >> v >> c;
    	u--, v--;

		vertex[u].pb(mp(v, c));
		vertex[v].pb(mp(u, c));
    }

    ans = inf;
    go(s);

	cout << ans << endl;


    return 0;
}
