/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem J. Journey from Petersburg to Moscow                   */
/*                                                                */
/* Original idea         Gleb Evstropov                           */
/* Problem statement     Gleb Evstropov                           */
/* Test set              Gleb Evstropov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Gleb Evstropov                           */
/******************************************************************/

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <queue>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 3100;
const long long inf = (long long) 1e18;

int n, m, k, s, t;
int par[size];
vector <pair <int, int> > vertex[size];
int vh[size], uh[size];
long long ch[size];
int u[size], v[size];
long long c[size];
long long dist[size];

long long get_path(long long shift) {
	priority_queue <pair <long long, int> > dst;

	for (int i = 0; i < n; i++) {
		dist[i] = inf;
	}
	dist[s] = 0ll;
	dst.push(mp(-dist[s], s));

    while (!dst.empty()) {
    	int cur = dst.top().sc;
    	long long cd = -dst.top().fs;
    	dst.pop();
    	if (cd != dist[cur])
    		continue;
    	
    	long long curd = dist[cur];
    	for (auto& e : vertex[cur]) {
    		int tg = e.fs;
    		long long reld = curd + max(0ll, e.sc - shift);
    		
    		if (reld < dist[tg]) {
    			dist[tg] = reld;
    			dst.push(mp(-dist[tg], tg));
    		}
    	}
    }

    return dist[t];
}

int getpar(int v) {
	if (par[v] != v) {
		par[v] = getpar(par[v]);
	}

	return par[v];
}

long long d[2][size];

long long get_kpath(int len) {
	for (int i = 0; i < n; i++) {
		d[0][i] = inf;
	}
	d[0][getpar(0)] = 0;
	int s = 0;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < n; j++)
			d[s ^ 1][j] = inf;
		for (int j = 0; j < len; j++) {
			if (d[s ^ 1][vh[j]] > d[s][uh[j]] + ch[j]) {
				d[s ^ 1][vh[j]] = d[s][uh[j]] + ch[j];
			}
			if (d[s ^ 1][uh[j]] > d[s][vh[j]] + ch[j]) {
				d[s ^ 1][uh[j]] = d[s][vh[j]] + ch[j];
			}
		}
		s ^= 1;
	}	

	return d[s][getpar(n - 1)];
}

int main () {
//    freopen("journey.in", "r", stdin);
//    freopen("journey.out", "w", stdout);
    scanf("%d%d%d", &n, &m, &k);
    s = 0, t = n - 1;

    vector <pair <long long, pair <int, int> > > alledges;
    for (int i = 0; i < m; i++) {
    	scanf("%d%d%lld", &u[i], &v[i], &c[i]);
    	alledges.pb(mp(c[i], mp(u[i], v[i])));
    }
    sort(alledges.begin(), alledges.end());
	for (int i = 0; i < m; i++) {
		u[i] = alledges[i].sc.fs - 1;
		v[i] = alledges[i].sc.sc - 1;
		c[i] = alledges[i].fs;

		vertex[u[i]].pb(mp(v[i], c[i]));
    	vertex[v[i]].pb(mp(u[i], c[i]));    
	}

    long long best = get_path(0);

    for (int i = 0; i < n; i++)
		par[i] = i;
	int cnt = n;
	for (int i = 0; i < m; i++) {
		int a = getpar(u[i]);
		int b = getpar(v[i]);
		if (a == b)
			continue;

		par[a] = b;
		cnt--;
		if (cnt <= k)
			break;

		int len = 0;
		for (int j = i + 1; j < m; j++) {
			uh[len] = getpar(u[j]);
			vh[len] = getpar(v[j]);
			ch[len] = c[j];
			if (uh[len] != vh[len]) {
//				cerr << "edge " << uh[len] << ' ' << vh[len] << ' ' << ch[len] << endl;
				len++;
			}
		}

//		cerr << "found " << get_kpath(len) << endl;
		best = min(best, get_kpath(len));
	}

    printf("%lld\n", best);

 //   cerr << (clock() + 0.0) / CLOCKS_PER_SEC << endl;

    return 0;
}
