/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem K. Knapsack Cryptosystem                               */
/*                                                                */
/* Original idea         Mikhail Dvorkin                          */
/* Problem statement     Mikhail Dvorkin                          */
/* Test set              Mikhail Dvorkin                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavsky                          */
/******************************************************************/

#include <cstdio>
#include <vector>
#include <cassert>
#include <string>
#include <algorithm>

using namespace std;

typedef unsigned long long ull;


vector<pair<ull, int>> all(const vector<ull> &v) {
  int n = (int)v.size();
  vector<pair<ull, int>> res(1 << n);
  for (int i = 0; i < (1 << n); i++) {
    res[i].second = i;
    for (int j = 0; j < n; j++) {
      if (i & (1 << j)) {
        res[i].first += v[j];
      }
    }
  }
  sort(res.begin(), res.end());
  return res;
}

int main() {
  int n;
  assert(scanf("%d", &n) == 1);
  vector<ull> b(n);
  for (int i = 0; i < n; i++) {
    assert(scanf("%llu", &b[i]) == 1);
  }
  ull s;
  assert(scanf("%llu", &s) == 1);

  if (n >= 44) {
    ull x = b[0];
    while (x % 2 == 0) x /= 2;
    ull y = 1;
    ull z = x;
    for (int i = 0; i < 63; i++) {
      y = y * z;
      z = z * z;
    }
    assert(x * y == 1);
    
    for (int i = 1; ; i += 2) {
      vector<ull> a(n);
      for (int j = 0; j < n; j++) {
        a[j] = b[j] * i * y;
      }
      string ans = "";
      ull ss = s * i * y;
      for (int j = n - 1; j >= 0; j--) {
        if (ss >= a[j]) {
          ss -= a[j];
          ans += "1";
        } else {
          ans += "0";
        }
      }
      if (ss == 0) {
        reverse(ans.begin(), ans.end());
        printf("%s\n", ans.c_str());
        return 0;
      }      
    }
  } else {
    int m = n / 2;
    vector<pair<ull, int>> p1 = all(vector<ull>(b.begin(), b.begin() + m));
    vector<pair<ull, int>> p2 = all(vector<ull>(b.begin() + m, b.end()));
    
    for (auto x : p1) {
      auto it = lower_bound(p2.begin(), p2.end(), make_pair(s - x.first, -1));
      if (it != p2.end()) {
        auto y = *it;
        if (x.first + y.first == s) {
          string ans = "";
          for (int i = 0; i < m; i++) {
            if (x.second & (1 << i)) {
              ans += "1";
            } else {
              ans += "0";
            }
          }
          for (int i = 0; i < n - m; i++) {
            if (y.second & (1 << i)) {
              ans += "1";
            } else {
              ans += "0";
            }
          }
          printf("%s\n", ans.c_str());
          return 0;
        }
      }
    }
    assert(false);
  }
}


