/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem L. Laminar Family                                      */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Checker                                                        */
/*                                                                */
/* Author                Maxim Akhmedov                           */
/******************************************************************/

import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;

import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
    private String readAns(InStream stream, Outcome.Type peOutcome) {
        String answer = stream.nextToken();
        if (!answer.equals("Yes") && !answer.equals("No")) {
            throw new Outcome(peOutcome, "`Yes` or `No` expected, `" +
                answer.substring(Math.min(10, answer.length())) + "` found");
        }
        if (!stream.seekEoF()) {
            throw new Outcome(peOutcome, "Extra information in the output file");
        }
        return answer;
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String ja = readAns(ans, Outcome.Type.FAIL);
        String pa = readAns(ouf, Outcome.Type.PE);
        if (!pa.equals(ja)) {
            throw new Outcome(WA, String.format("Jury answer: `%s`, contestant answer: `%s`", ja, pa));
        } else {
            throw new Outcome(OK, String.format("Answer: %s", ja));
        }
    }
}

