/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem L. Laminar Family                                      */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Maxim Akhmedov                           */
/******************************************************************/

#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
using namespace std;

const int N = 500500;
vector<int> E[N];

#define scanf(...) assert(scanf(__VA_ARGS__))

vector<int> tmp;
bool buildPath(int a, int b, int prv = -1) {
    if (a == b) {
        tmp.push_back(a);
        return true;
    }
    for (int x : E[a]) {
        if (x == prv)
            continue;
        if (buildPath(x, b, a)) {
            tmp.push_back(a);
            return true;
        }
    }
    return false;
}

vector<int> path(int a, int b) {
    buildPath(a, b);
    vector<int> ret;
    ret.swap(tmp);
    return ret;
}

bool check(vector<int> a, vector<int> b) {
    if (a.size() > b.size()) {
        a.swap(b);
    }
    sort(b.begin(), b.end());
    int cnt = 0;
    for (int x : a) {
        cnt += (int)binary_search(b.begin(), b.end(), x);
    }
    return cnt == 0 || cnt == (int)a.size();
}

int main() {
    int n, k;
    scanf("%d %d", &n, &k);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        E[a].push_back(b);
        E[b].push_back(a);
    }
    vector<pair<int, int>> paths;
    for (int i = 0; i < k; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        paths.emplace_back(a, b);
    }

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < i; j++) {
            if (!check(path(paths[i].first, paths[i].second), path(paths[j].first, paths[j].second))) {
                puts("No");
                return 0;
            }
        }
    }
    puts("Yes");
    return 0;
}

