/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem L. Laminar Family                                      */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavsky                          */
/******************************************************************/

#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int MAXN = 210000;

vector<int> g[MAXN];
vector<int> tm[MAXN];
int timer;

void dfs(int v, int p) {
  tm[v].push_back(timer++);
  for (int u : g[v]) {
    if (u != p) {
      dfs(u, v);
      tm[v].push_back(timer++);
    }
  }
  tm[v].push_back(timer++);
}

struct event {
  int pos;
  int ty;
  int val;
};

int main() {
  int n, m;
  assert(scanf("%d%d", &n, &m) == 2);
  for (int i = 0; i < n - 1; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    --a, --b;
    g[a].push_back(b);
    g[b].push_back(a);
  }

  dfs(0, -1);
  vector<event> v;
  for (int i = 0; i < m; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
  //  fprintf(stderr, "%d,%d -> ", a, b);
    --a, --b;
    if (tm[a].back() > tm[b].back()) swap(a, b);
    a = tm[a].back();
    b = *lower_bound(tm[b].begin(), tm[b].end(), a);
    if (a > b) swap(a, b);
   // fprintf(stderr, "[%d..%d]\n", a, b);
    v.push_back({a, -1, a});
    v.push_back({b,  1, a});
  }
  sort(v.begin(), v.end(), [] (const event & a, const event & b) {
        if (a.pos != b.pos) return a.pos < b.pos;
        if (a.ty != b.ty) return a.ty < b.ty;
        return a.val * a.ty > b.val * b.ty;
      });

  vector<int> st;
  for (auto x : v) {
    if (x.ty == -1) {
      st.push_back(x.val);
    } else {
      if (st.back() != x.val) {
        printf("No\n");
        return 0;
      }
      st.pop_back();
    }
  }
  printf("Yes\n");
  return 0;
}

