/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem L. Laminar Family                                      */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Pavel Kunyavsky                          */
/******************************************************************/

#include <cstdio>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int MAXN = 210000;

vector<int> g[MAXN];
vector<int> tm[MAXN];
int timer;

void dfs(int v, int p) {
  tm[v].push_back(timer++);
  for (int u : g[v]) {
    if (u != p) {
      dfs(u, v);
      tm[v].push_back(timer++);
    }
  }
  if (tm[v].size() == 1) tm[v].push_back(timer++);
}

struct event {
  int pos;
  int ty;
  int val;
};

int main() {
  int n, m;
  assert(scanf("%d%d", &n, &m) == 2);
  for (int i = 0; i < n - 1; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    --a, --b;
    g[a].push_back(b);
    g[b].push_back(a);
  }

  for (int i = 0; i < n; i++) {
    random_shuffle(g[i].begin(), g[i].end());
  }

  dfs(rand() % n, -1);
  vector<event> v;
  for (int i = 0; i < m; i++) {
    int a, b;
    assert(scanf("%d%d", &a, &b) == 2);
    //fprintf(stderr, "%d,%d -> ", a, b);
    --a, --b;
    if (tm[a].back() > tm[b].back()) swap(a, b);
    int t1, t2;
    t1 = tm[a].back();
    t2 = *lower_bound(tm[b].begin(), tm[b].end(), t1);
    v.push_back({t1, -1, t1});
    v.push_back({t2,  1, t1});
    //fprintf(stderr, "[%d..%d]", t1, t2);
    if (tm[a][0] > tm[b][0]) {
      t2 = tm[a][0];
      t1 = *--lower_bound(tm[b].begin(), tm[b].end(), t2);
      v.push_back({t1, -1, t1});
      v.push_back({t2,  1, t1});
      //fprintf(stderr, ",[%d..%d]", t1, t2);
    }
    //fprintf(stderr, "\n");
  }
  sort(v.begin(), v.end(), [] (const event & a, const event & b) {
        if (a.pos != b.pos) return a.pos < b.pos;
        if (a.ty != b.ty) return a.ty < b.ty;
        return a.val * a.ty > b.val * b.ty;
      });

  vector<int> st;
  for (auto x : v) {
    //fprintf(stderr, "%d %d %d\n", x.pos, x.ty, x.val);
    if (x.ty == -1) {
      st.push_back(x.val);
    } else {
      if (st.back() != x.val) {
        printf("No\n");
        return 0;
      }
      st.pop_back();
    }
  }
  printf("Yes\n");
  return 0;
}

