/******************************************************************/
/* ACM ICPC 2017-2018                                             */
/* NEERC - Northern Eurasia Finals                                */
/* St Petersburg - Barnaul - Tbilisi - Almaty, December 3, 2017   */
/******************************************************************/
/* Problem L. Laminar Family                                      */
/*                                                                */
/* Original idea         Maxim Akhmedov                           */
/* Problem statement     Maxim Akhmedov                           */
/* Test set              Maxim Akhmedov                           */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Sergey Melnikov                          */
/******************************************************************/

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.StringTokenizer;
 
public class laminarity_sm {
    FastScanner in;
    PrintWriter out;
 
    class NoException extends RuntimeException {
    }
 
    NoException No = new NoException();
    ArrayList<Integer>[] es;
    HashSet<Integer>[] ss;
 
    class State {
        HashSet<Integer> all;
        ArrayDeque<HashSet<Integer>> stack;
 
        public State() {
            all = new HashSet<>();
            stack = new ArrayDeque<>();
        }
 
        boolean isEmpty() {
            return all.isEmpty();
        }
 
        @Override
        public String toString() {
            return stack + " all: " + all;
        }
    }
    final boolean DEBUG = false;
    public void solve() throws IOException {
        int n = in.nextInt();
        int f = in.nextInt();
        es = new ArrayList[n + 1];
        ss = new HashSet[n + 1];
        for (int i = 0; i <= n; i++) {
            es[i] = new ArrayList<>();
            ss[i] = new HashSet<>();
        }
        for (int i = 0; i < n - 1; i++) {
            int a = in.nextInt();
            int b = in.nextInt();
            es[a].add(b);
            es[b].add(a);
        }
        for (int i = 0; i < f; i++) {
            int a = in.nextInt();
            int b = in.nextInt();
            if (a == b) {
                continue;
            }
            ss[a].add(i);
            ss[b].add(i);
        }
        try {
            dfs(1, -1);
        } catch (NoException no) {
            out.println("No");
            return;
        }
        out.println("Yes");
    }
 
    State dfs(int v, int p) {
        ArrayList<State> childs = new ArrayList<>(2);
        for (int e : es[v]) {
            if (e == p) {
                continue;
            }
            State s = dfs(e, v);
            if (s != null && !s.isEmpty()) {
                childs.add(s);
            }
        }
        if (childs.isEmpty()) {
            childs.add(new State());
        }
        if (DEBUG) System.err.println("");
        if (DEBUG) System.err.println("I'm in " + v + ", my childs are " + childs);
        State firstChild = childs.get(0);
        boolean hasAny = false;
        boolean hasAll = true;
        for (int segments : ss[v]) {
            if (firstChild.all.contains(segments)) {
                hasAny = true;
            } else {
                hasAll = false;
            }
        }
        if (hasAny) {
            if (!hasAll) {
                throw No;
            }
            if (DEBUG) System.err.println("Removing " + ss[v] + " from " + firstChild + " with merge");
            State ephemeral = new State();
            ephemeral.all = new HashSet<>(ss[v]);
            ephemeral.stack.addLast(new HashSet<>(ss[v]));
            firstChild = merge(firstChild, ephemeral);
        } else {
            if (DEBUG) System.err.println("Adding " + ss[v] + " to " + firstChild);
            //Not hasAny
            HashSet<Integer> newLayer = new HashSet<>();
            for (int segments : ss[v]) {
                newLayer.add(segments);
                firstChild.all.add(segments);
            }
            firstChild.stack.addLast(newLayer);
        }
        childs.set(0, firstChild);
        if (childs.size() == 1) {
            if (DEBUG) System.err.println("Returning from " + v + " " + firstChild);
            return firstChild;
        } else if (childs.size() == 2) {
            State merged = merge(childs.get(0), childs.get(1));
            if (!merged.isEmpty()) {
                throw No;
            }
            if (DEBUG) System.err.println("Returning from " + v + " " + merged);
            return merged;
        } else {
            throw No;
        }
    }
 
    State merge(State a, State b) {
        if (DEBUG) System.err.println(a + " merging " + b);
        while (!a.isEmpty() && !b.isEmpty()) {
            if (a.stack.getLast().size() > b.stack.getLast().size()) {
                State tmp = a;
                a = b;
                b = tmp;
            }
            b.all.removeAll(a.stack.getLast());
            if (!b.stack.getLast().containsAll(a.stack.getLast()) ) {
                throw No;
            }
            b.stack.getLast().removeAll(a.stack.getLast());
            if (b.stack.getLast().isEmpty()) {
                b.stack.removeLast();
            }
            a.all.removeAll(a.stack.getLast());
            a.stack.removeLast();
        }
        if (DEBUG) System.err.println("Result: " + a + " or " + b);
        if (!a.isEmpty()) {
            return a;
        }
        return b;
    }
 
    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);
            solve();
 
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
 
    class FastScanner {
        BufferedReader br;
        StringTokenizer st;
 
        FastScanner() {
            br = new BufferedReader(new InputStreamReader(System.in));
        }
 
        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }
 
        int nextInt() {
            return Integer.parseInt(next());
        }
 
        long nextLong() {
            return Long.parseLong(next());
        }
 
        double nextDouble() {
            return Double.parseDouble(next());
        }
    }
 
    public static void main(String[] arg) {
        new laminarity_sm().run();
    }
}

